# Copyright 1999-2012 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=4
JAVA_PKG_IUSE="source"

inherit java-pkg-2 java-ant-2

DESCRIPTION="Java PDF Renderer"
HOMEPAGE="http://www.icepdf.org/"
SRC_URI="${PN}-${PV}-src.zip"
RESTRICT="fetch"

LICENSE="MPL-1.1"
SLOT="0"
KEYWORDS="~x86 ~amd64"
IUSE=""

COMMON_DEP="
	dev-java/batik:1.7"

RDEPEND=">=virtual/jre-1.5
	${COMMON_DEP}"
DEPEND=">=virtual/jdk-1.5
	app-arch/unzip
	${COMMON_DEP}"

S=${WORKDIR}/${PN}-${PV}-src/icepdf

java_prepare() {
	cd lib || die
	rm -vf *.jar || die
	java-pkg_jar-from batik-1.7
}

EANT_BUILD_TARGET="build.jars"

src_install() {
	java-pkg_dojar lib/icepdf-core.jar lib/icepdf-viewer.jar
	use source && java-pkg_dosrc core/src viewer/src
}
