# Copyright 1999-2012 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=4

JAVA_PKG_IUSE="source doc"
JAVA_ANT_REWRITE_CLASSPATH="true"
EANT_GENTOO_CLASSPATH="swt-3.4,isfreetype,isnativec,isrt,jna"

inherit java-pkg-2 java-ant-2

DESCRIPTION="This is a window toolkit and basic rendering abstraction layer."
HOMEPAGE="http://opensource.intarsys.de/"
SRC_URI="mirror://sourceforge/jpodrenderer/isCWT.${PV}.zip"

LICENSE="BSD"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

COMMON_DEP="dev-java/jna:0
	    dev-java/swt:3.4
	    dev-java/isrt:0
	    dev-java/isnativec:0
	    dev-java/isfreetype:0"
RDEPEND=">=virtual/jre-1.6
	${COMMON_DEP}"
DEPEND=">=virtual/jdk-1.6
	${COMMON_DEP}
	app-arch/unzip"

S="${WORKDIR}"/distribution

java_prepare() {
	cp "${FILESDIR}"/build.* "${S}"
}

src_install() {
	java-pkg_dojar build/iscwt/dist/iscwt.jar

	use source && java-pkg_dosrc src/*

	use doc && java-pkg_dojavadoc build/iscwt/javadoc
}
