# Copyright 1999-2012 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=4

JAVA_PKG_IUSE="source doc"
JAVA_ANT_REWRITE_CLASSPATH="true"
EANT_GENTOO_CLASSPATH="isrt,jna"

inherit java-pkg-2 java-ant-2

DESCRIPTION="This is a generic native code wrapper."
HOMEPAGE="http://opensource.intarsys.de/"
SRC_URI="mirror://sourceforge/jpodrenderer/isNative.${PV}.zip"

LICENSE="BSD"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

COMMON_DEP="dev-java/jna:0
	   dev-java/isrt:0"
RDEPEND=">=virtual/jre-1.5
	${COMMON_DEP}"
DEPEND=">=virtual/jdk-1.5
	${COMMON_DEP}
	app-arch/unzip"

S="${WORKDIR}"/distribution

java_prepare() {
	cp "${FILESDIR}"/build.* "${S}" || die
}

src_install() {
	java-pkg_dojar build/isnativec/dist/isnativec.jar

	use source && java-pkg_dosrc src/*

	use doc && java-pkg_dojavadoc build/isnativec/javadoc
}
