# Copyright 1999-2012 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=4

JAVA_PKG_IUSE="source doc"
JAVA_ANT_REWRITE_CLASSPATH="true"
EANT_GENTOO_CLASSPATH="jai-imageio,sun-jai-bin,jbig2,swt-3.4,jPod,iscwt,isfreetype,isnativec,isrt,jna"

inherit java-pkg-2 java-ant-2

DESCRIPTION="This is the jPod based PDF platform & rendering library."
HOMEPAGE="http://opensource.intarsys.de/"
SRC_URI="mirror://sourceforge/jpodrenderer/jPodRenderer.${PV}.zip"

LICENSE="BSD"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

COMMON_DEP="dev-java/jai-imageio:0
	    dev-java/sun-jai-bin:0
	    dev-java/jbig2:0
	    dev-java/jna:0
	    dev-java/swt:3.4
	    dev-java/isrt:0
	    dev-java/isnativec:0
	    dev-java/isfreetype:0
	    dev-java/iscwt:0
	    dev-java/jPod:0"
RDEPEND=">=virtual/jre-1.6
	${COMMON_DEP}"
DEPEND=">=virtual/jdk-1.6
	${COMMON_DEP}
	app-arch/unzip"

S="${WORKDIR}"/distribution

java_prepare() {
	cp "${FILESDIR}"/build.* "${S}" || die
}

src_install() {
	java-pkg_dojar build/jPodRenderer/dist/jPodRenderer.jar
	java-pkg_dojar lib/jPodFonts.jar

	use source && java-pkg_dosrc src/*

	use doc && java-pkg_dojavadoc build/jPodRenderer/javadoc
}
