# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=2

MY_P=${P/_p/-}
MY_PV=${PV/_p*/}

inherit autotools eutils multilib

DESCRIPTION="NX compression technology core libraries"
HOMEPAGE="http://www.nomachine.com/developers.php"
SRC_URI="http://web04.nomachine.com/download/${MY_PV}/sources/${MY_P}.tar.gz"

LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

RDEPEND="x11-libs/libX11
	>=media-libs/jpeg-6b-r4
	>=media-libs/libpng-1.2.8
	>=sys-libs/zlib-1.2.3
	!<net-misc/nx-${MY_PV}
	>=net-misc/nxcomp-${MY_PV}"

DEPEND="${RDEPEND}"

S=${WORKDIR}/nxcompext

src_prepare() {
	# Respect CFLAGS/CXXFLAGS
	epatch "${FILESDIR}"/nxcompext-3.4.0-cflags.patch
	# Use System nxcomp
	epatch "${FILESDIR}"/nxcompext-3.4.0-no-local-nxcomp.patch
	# IOError
	epatch "${FILESDIR}"/nxcompext-3.4.0-NXlib-xgetioerror.patch
	# Run autoreconf in all neeed folders
	eautoreconf
}

src_install() {
	# Install Libs
	dolib libXcompext.a
	dolib.so libXcompext.so*
	# Install Header
	insinto /usr/include/nx
	doins NX*.h
}
