# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=2

MY_P=${P/_p/-}
MY_PV=${PV/_p*/}

inherit autotools eutils multilib

DESCRIPTION="NX compression technology core libraries"
HOMEPAGE="http://www.nomachine.com/developers.php"
SRC_URI="http://web04.nomachine.com/download/${MY_PV}/sources/${MY_P}.tar.gz"

LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

RDEPEND="x11-libs/libX11
	x11-libs/libXdamage
	x11-libs/libXext
	x11-libs/libXrandr
	x11-libs/libXtst
	>=media-libs/jpeg-6b-r4
	>=media-libs/libpng-1.2.8
	>=sys-libs/zlib-1.2.3
	!<net-misc/nx-${MY_PV}
	>=net-misc/nxcomp-${MY_PV}"

DEPEND="${RDEPEND}"

S=${WORKDIR}/nxcompshad

src_prepare() {
	# Respect CFLAGS/CXXFLAGS
	epatch "${FILESDIR}"/nxcompshad-3.4.0-cflags.patch
	# Use System nxcomp
	epatch "${FILESDIR}"/nxcompshad-3.4.0-system_wide_build.patch
	# Gcc 4.3 build problem
	epatch "${FILESDIR}"/nxcompshad-3.2.0-gcc43.patch
	# link with xext
	epatch "${FILESDIR}"/nxcompshad-3.3.0-Xext.patch
	# Run autoreconf in all neeed folders
	eautoreconf
}

src_install() {
	# Install Libs
	dolib libXcompshad.a
	dolib.so libXcompshad.so*
	# Install Header
	insinto /usr/include/nx
	doins *.h
}
