# Copyright 1999-2010 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI=2

MY_P=${P/_p/-}
MY_PV=${PV/_p*/}

inherit autotools eutils multilib

DESCRIPTION="NX compression technology core libraries"
HOMEPAGE="http://www.nomachine.com/developers.php"
SRC_URI="http://web04.nomachine.com/download/${MY_PV}/sources/${MY_P}.tar.gz"

LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86"
IUSE=""

RDEPEND="!<net-misc/nx-${MY_PV}
	>=net-misc/nxcomp-${MY_PV}"

DEPEND="${RDEPEND}"

S=${WORKDIR}/nxproxy

src_prepare() {
	# RESPECT cflags
	epatch "${FILESDIR}"/nxproxy-3.3.0-cflags.patch
	# read from stdin from the x2go nxproxy
	epatch "${FILESDIR}"/nxproxy-3.2.0-read_from_stdin.patch
	# make isnatll with DESTDIR
	epatch "${FILESDIR}"/nxproxy-3.4.0-build_destdir.patch
	# non local nxcomp
	epatch "${FILESDIR}"/nxproxy-3.4.0-no-local-nxcomp-1.patch
	# Run autoreconf in all neeed folders
	eautoreconf
}

src_install() {
	emake DESTDIR="${D}" install || die "Install failed"
}
